from concho.dell import DellMatinfoCsvConfigurator
from concho.dell import DellMatinfoConfigurator
from concho.dell import DellConfiguratorParser2020
from concho.dell import DellConfiguratorParser2021
from concho.procs_chooser import plot_configurators
from concho.procs_chooser import ConfigPrice
from concho.procs_chooser import ConfigFlops
from concho.procs_chooser import ConfigFlopsPerEuro

def test_all_matinfo_2020_configs():
    # configurator = DellMatinfoConfigurator('rcrc1406676-4834664 - Cat2 Conf4 PowerEdge R640 - Dell.html')
    # print(configurator)
    configurators = [
        DellMatinfoCsvConfigurator('c6420-20200716-price.tsv'),
        DellMatinfoConfigurator('rcrc1406676-4834664 - Cat2 Conf4 PowerEdge R640 - Dell.html', DellConfiguratorParser2020()),
        DellMatinfoConfigurator('rcrc1406676-4824727 - Cat 2 Conf 7 PowerEdge R940 - Dell.html', DellConfiguratorParser2020()),
        # dell.DellPowerEdgeR940(),
        ]
    
    plot_configurators(configurators=configurators, ram_per_core=4.0e9, xaxis_def=ConfigPrice(), yaxis_def=ConfigFlopsPerEuro(), plot_title='total cost including electricity')

def test_credits_2020_configs():
    # configurator = DellMatinfoConfigurator('rcrc1406676-4834664 - Cat2 Conf4 PowerEdge R640 - Dell.html')
    # print(configurator)
    configurators = [
        DellMatinfoCsvConfigurator('c6420-20200716-price.tsv'),
        DellMatinfoConfigurator('rcrc1406676-4834664 - Cat2 Conf4 PowerEdge R640 - Dell.html', DellConfiguratorParser2020()),
        DellMatinfoConfigurator('rcrc1406676-4824727 - Cat 2 Conf 7 PowerEdge R940 - Dell.html', DellConfiguratorParser2020()),
        # dell.DellPowerEdgeR940(),
        ]
    
    # config_filter = lambda config : config.cpu.uid in [
    #     'intel-xeon-gold-5222',
    #     'intel-xeon-gold-6226r',
    #     'intel-xeon-gold-6230r',
    #     'intel-xeon-gold-6234r',
    #     'intel-xeon-gold-6240r',
    #     'intel-xeon-gold-6248r',
    #     'intel-xeon-gold-6230',
    #     'intel-xeon-gold-6240',
    #     ]

    config_filter = lambda config : config.get_price() < 40000.0

    plot_configurators(configurators=configurators, ram_per_core=4.0e9, xaxis_def=ConfigPrice(), yaxis_def=ConfigFlopsPerEuro(), plot_title='physmol/ts credit 2020 configs', config_filter=config_filter)

def test_credits_2021_configs():
    configurators = [
        DellMatinfoConfigurator('20210407 - Cat2 Conf4 PowerEdge R640 - Dell.html', DellConfiguratorParser2021()),
        DellMatinfoConfigurator('20210407 - Cat2 Conf7 PowerEdge R940 - Dell.html', DellConfiguratorParser2021()),
        DellMatinfoConfigurator('20210407 - Cat2 Conf10 PowerEdge R6525 - Dell.html', DellConfiguratorParser2021()),
        ]
    
    # config_filter = lambda config : config.cpu.uid in [
    #     'intel-xeon-gold-5222',
    #     'intel-xeon-gold-6226r',
    #     'intel-xeon-gold-6230r',
    #     'intel-xeon-gold-6234r',
    #     'intel-xeon-gold-6240r',
    #     'intel-xeon-gold-6248r',
    #     'intel-xeon-gold-6230',
    #     'intel-xeon-gold-6240',
    #     ]

    config_filter = lambda config : config.get_price() < 20000.0

    plot_configurators(configurators=configurators, ram_per_core=4.0e9, xaxis_def=ConfigPrice(), yaxis_def=ConfigFlopsPerEuro(), plot_title='physmol/ts credit 2021 configs', config_filter=config_filter)


if __name__ == '__main__':
    test_credits_2021_configs()